import pickle
from PIL import Image
import numpy as np
import matplotlib.pyplot as plt
import pickle
import traceback
import uuid
from dataclasses import asdict
from datetime import datetime
from pathlib import Path
from typing import Any, Dict, List, Union, Tuple
import torch

import hydra
from hydra.utils import instantiate
from nuplan.planning.script.builders.logging_builder import build_logger
from nuplan.planning.utils.multithreading.worker_utils import worker_map
from omegaconf import DictConfig

from typing import Any, Dict, List, Tuple
import traceback
import pickle
import hydra
import cv2
import numpy as np
from torchvision import transforms
from navsim.agents.abstract_agent import AbstractAgent
CONFIG_PATH = "../config/pdm_scoring"
CONFIG_NAME = "default_run_create_submission_pickle_ddp"

@hydra.main(config_path=CONFIG_PATH, config_name=CONFIG_NAME)
def main(cfg: DictConfig):

    agent: AbstractAgent = instantiate(cfg.agent)
    agent._checkpoint_path = "/mnt/f/e2e/navsim_ours/models_local/v2ego.ckpt"
    agent.initialize()
    agent.vadv2_model = agent.vadv2_model.cuda()
    dump_name = 'ego_2048x512.pkl'

    results = []

    for i in range(601):
        path = f"/mnt/g/cvpr_demo/data-{i}.pkl"
        data = pickle.load(open(path, 'rb'))
        if "cameras" in data:
            cams = data["cameras"]
            # numpy array
            f0 = cams['CAM_F0']['image'][28:-28]
            l0 = cams['CAM_L0']['image'][28:-28, 416:-416]
            r0 = cams['CAM_R0']['image'][28:-28, 416:-416]

            b0 = cams['CAM_B0']['image'][28:-28]
            l2 = cams['CAM_L2']['image'][28:-28, 416:-416]
            r2 = cams['CAM_R2']['image'][28:-28, 416:-416]


            stitched_image = np.concatenate([l0, f0, r0], axis=1)
            resized_image = cv2.resize(stitched_image, (2048, 512))
            tensor_image = transforms.ToTensor()(resized_image)
            velo = torch.from_numpy(data['ego']['velocity_xyz_mps']).to(torch.float32)
            if i == 0:
                acc = torch.zeros_like(velo)
            else:
                prev_data = pickle.load(open(f"/mnt/g/cvpr_demo/data-{i-1}.pkl", 'rb'))
                acc = (data['ego']['velocity_xyz_mps'] - prev_data['ego']['velocity_xyz_mps']) / 0.0333
                acc = torch.from_numpy(acc).to(torch.float32)
            nav = torch.zeros(4, dtype=torch.float32)
            # todo eyeball
            nav[1] = 1.0
            input_dict = {
                "camera_feature": tensor_image[None].cuda(),
                "status_feature": torch.cat([
                    nav,
                    velo[:2],
                    acc[:2]
                ])[None].cuda()
            }
            results.append(agent(input_dict)['trajectory'].cpu().numpy())
            print(i)

    pickle.dump(results, open(f'/mnt/f/e2e/navsim_ours/debug/cvpr_demo/{dump_name}', 'wb'))



if __name__ == "__main__":
    with torch.no_grad():
        main()